# TMCColorRGB Class Reference
[MCCore]

Inheritance diagram for TMCColorRGB:

List of all members.

## Public Member Functions
| TMCColorRGB (void)
| TMCColorRGB (const real rr, const real gg, const real bb)
| TMCColorRGB (const TMCColorRGB &inColor)
| TMCColorRGB (const TMCRGBColor &inColor)
void | Set (const real rr, const real gg, const real bb)
boolean | IsEqual (const TMCColorRGB &rhs, const real epsilon=0.0) const
real | GetMagnitude (void) const
real | GetMagnitudeSquared (void) const
real | GetMinOfRGB (void) const
real | GetMaxOfRGB (void) const
boolean | IsClamped (void) const
void | Clamp (void)
void | Interpolate (const TMCColorRGB &from, const TMCColorRGB &to, const real interpolant)
void | Interpolate (const TVector2 &interpolants, const TMCColorRGB &lowerLeft, const TMCColorRGB &lowerRight, const TMCColorRGB &upperLeft, const TMCColorRGB &upperRight)
void | AccumRGB (const TMCColorRGB &rhs, const real scalar)
boolean | operator== (const TMCColorRGB &rhs) const
boolean | operator!= (const TMCColorRGB &rhs) const
boolean | operator< (const real t)
boolean | operator> (const real t)
TMCColorRGB & | operator+= (const TMCColorRGB &rhs)
TMCColorRGB & | operator-= (const TMCColorRGB &rhs)
TMCColorRGB & | operator*= (const real s)
TMCColorRGB & | operator/= (const real s)
TMCColorRGB | operator+ (const TMCColorRGB &rhs) const
TMCColorRGB | operator- (const TMCColorRGB &rhs) const
TMCColorRGB | operator* (const real s) const
TMCColorRGB | operator/ (const real s) const
TMCColorRGB & | Neg ()
real | operator* (const TMCColorRGB &rhs) const
TMCColorRGB | operator% (const TMCColorRGB &rhs) const
TMCColorRGBA8 & | ToRGBA8 (TMCColorRGBA8 &c, const uint8 alphaValue) const
TMCColorRGBA8 & | ToRGBA8Unclamped (TMCColorRGBA8 &c, const uint8 alphaValue) const
TMCColorRGBA & | ToRGBA (TMCColorRGBA &c, const float alphaValue) const
void | FromTMCRGBColor (const TMCRGBColor &inColor)
void | ToTMCRGBColor (TMCRGBColor &outColor) const
TMCColorRGB & | operator= (class TMCColorRGBA &c)
real & | operator[] (int32 i)
const real | operator[] (int32 i) const
const real * | GetAddrFirstComponent (void) const
real | Intensity () const
void | GetHLS (real32 &H, real32 &L, real32 &S) const
void | SetHLS (const real32 h, const real32 l, const real32 s)
## Public Attributes
union {
real red
real R
}; |
union {
real green
real G
}; |
union {
real blue
real B
}; |
## Static Public Attributes
static const real | kMaxIntensity
| equals 1.0f
static const real | kInvMaxIntensity
| equals 1.0f/kMaxIntensity;
static const TMCColorRGB | kBlack
| (0,0,0);
static const TMCColorRGB | kWhite
| (kMaxIntensity,kMaxIntensity,kMaxIntensity);

## Detailed Description

TMCColorRGB is the floating point color used for most calculations since it can do interpolation without converting int-to-float.
Regular colors are supposed to be between zero (black) and one.

Other color classes are TMCColorRGBA, TMCColorRGBA32, TMCColorRGBA8

## Constructor & Destructor Documentation

TMCColorRGB::TMCColorRGB | ( | void |  | ) | `[inline]`

TMCColorRGB::TMCColorRGB | ( | const real | rr,
|  | const real | gg,
|  | const real | bb |
| ) |  |  | `[inline]`

TMCColorRGB::TMCColorRGB | ( | const TMCColorRGB & | inColor | ) | `[inline]`

TMCColorRGB::TMCColorRGB | ( | const TMCRGBColor & | inColor | ) | `[inline]`

## Member Function Documentation

void TMCColorRGB::AccumRGB | ( | const TMCColorRGB & | rhs,
|  | const real | scalar |
| ) |  |  | `[inline]`

void TMCColorRGB::Clamp | ( | void |  | ) |

Reimplemented in TMCColorRGBA.

void TMCColorRGB::FromTMCRGBColor | ( | const TMCRGBColor & | inColor | ) | `[inline]`

const real * TMCColorRGB::GetAddrFirstComponent | ( | void |  | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

void TMCColorRGB::GetHLS | ( | real32 & | H,
|  | real32 & | L,
|  | real32 & | S |
| ) |  |  | const

real TMCColorRGB::GetMagnitude | ( | void |  | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

real TMCColorRGB::GetMagnitudeSquared | ( | void |  | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

real TMCColorRGB::GetMaxOfRGB | ( | void |  | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

real TMCColorRGB::GetMinOfRGB | ( | void |  | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

real TMCColorRGB::Intensity | ( |  | ) | const`[inline]`

void TMCColorRGB::Interpolate | ( | const TVector2 & | interpolants,
|  | const TMCColorRGB & | lowerLeft,
|  | const TMCColorRGB & | lowerRight,
|  | const TMCColorRGB & | upperLeft,
|  | const TMCColorRGB & | upperRight |
| ) |  |  |

void TMCColorRGB::Interpolate | ( | const TMCColorRGB & | from,
|  | const TMCColorRGB & | to,
|  | const real | interpolant |
| ) |  |  |

boolean TMCColorRGB::IsClamped | ( | void |  | ) | const

Reimplemented in TMCColorRGBA.

boolean TMCColorRGB::IsEqual | ( | const TMCColorRGB & | rhs,
|  | const real | epsilon = `0.0` |
| ) |  |  | const

TMCColorRGB & TMCColorRGB::Neg | ( |  | ) | `[inline]`

boolean TMCColorRGB::operator!= | ( | const TMCColorRGB & | rhs | ) | const`[inline]`

TMCColorRGB TMCColorRGB::operator% | ( | const TMCColorRGB & | rhs | ) | const`[inline]`

real TMCColorRGB::operator* | ( | const TMCColorRGB & | rhs | ) | const`[inline]`

TMCColorRGB TMCColorRGB::operator* | ( | const real | s | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

TMCColorRGB & TMCColorRGB::operator*= | ( | const real | s | ) | `[inline]`

Reimplemented in TMCColorRGBA.

TMCColorRGB TMCColorRGB::operator+ | ( | const TMCColorRGB & | rhs | ) | const`[inline]`

TMCColorRGB & TMCColorRGB::operator+= | ( | const TMCColorRGB & | rhs | ) | `[inline]`

Reimplemented in TMCColorRGBA.

TMCColorRGB TMCColorRGB::operator- | ( | const TMCColorRGB & | rhs | ) | const`[inline]`

TMCColorRGB & TMCColorRGB::operator-= | ( | const TMCColorRGB & | rhs | ) | `[inline]`

TMCColorRGB TMCColorRGB::operator/ | ( | const real | s | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

TMCColorRGB & TMCColorRGB::operator/= | ( | const real | s | ) | `[inline]`

Reimplemented in TMCColorRGBA.

boolean TMCColorRGB::operator< | ( | const real | t | ) | `[inline]`

TMCColorRGB & TMCColorRGB::operator= | ( | class TMCColorRGBA & | c | ) | `[inline]`

boolean TMCColorRGB::operator== | ( | const TMCColorRGB & | rhs | ) | const`[inline]`

boolean TMCColorRGB::operator> | ( | const real | t | ) | `[inline]`

const real TMCColorRGB::operator[] | ( | int32 | i | ) | const`[inline]`

Reimplemented in TMCColorRGBA.

real& TMCColorRGB::operator[] | ( | int32 | i | ) | `[inline]`

Reimplemented in TMCColorRGBA.

void TMCColorRGB::Set | ( | const real | rr,
|  | const real | gg,
|  | const real | bb |
| ) |  |  | `[inline]`

void TMCColorRGB::SetHLS | ( | const real32 | h,
|  | const real32 | l,
|  | const real32 | s |
| ) |  |  |

TMCColorRGBA& TMCColorRGB::ToRGBA | ( | TMCColorRGBA & | c,
|  | const float | alphaValue |
| ) |  |  | const

TMCColorRGBA8& TMCColorRGB::ToRGBA8 | ( | TMCColorRGBA8 & | c,
|  | const uint8 | alphaValue |
| ) |  |  | const

TMCColorRGBA8& TMCColorRGB::ToRGBA8Unclamped | ( | TMCColorRGBA8 & | c,
|  | const uint8 | alphaValue |
| ) |  |  | const

void TMCColorRGB::ToTMCRGBColor | ( | TMCRGBColor & | outColor | ) | const`[inline]`

## Member Data Documentation

union { ... }

union { ... }

union { ... }

real TMCColorRGB::B

real TMCColorRGB::blue

real TMCColorRGB::G

real TMCColorRGB::green

const TMCColorRGB TMCColorRGB::kBlack`[static]`

(0,0,0);

const real TMCColorRGB::kInvMaxIntensity`[static]`

equals 1.0f/kMaxIntensity;

Reimplemented in TMCColorRGBA.

const real TMCColorRGB::kMaxIntensity`[static]`

equals 1.0f

Reimplemented in TMCColorRGBA.

const TMCColorRGB TMCColorRGB::kWhite`[static]`

(kMaxIntensity,kMaxIntensity,kMaxIntensity);

real TMCColorRGB::R

real TMCColorRGB::red

The documentation for this class was generated from the following files:

- MCColorRGB.h
- MCColorRGBA.h